package net.antonioshome.clexec;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.ThreadFactory;

/**
 * The ExecutorService used to launch and pipe external processes.
 * @author Antonio Vieiro (antonio@antonioshome.net)
 * @author $Author: $
 * @version $Revision: $
 */
class ProcessExecutionService
{
  private static ExecutorService service;

  public static synchronized ExecutorService getService()
  {
    if ( service == null )
    {
      /* Don't use a fixed thread pool. Each process requires 4 threads
       * (3 pipes and a running process thread) and we don't want 
       * thread starvation on those. */
      service = Executors.newCachedThreadPool( threadFactory );
    }
    return service;
  }

  /**
   * A thread factory that creates daemon threads (so that the JVM can
   * exit without requiring a shutdown.
   * TODO: What about doing some statistics here for performance, etc.?
   */
  private static ThreadFactory threadFactory = new ThreadFactory() {
    public Thread newThread(Runnable r)
    {
      Thread t = new Thread( r, "COMMAND_LINE_EXECUTION");
      t.setDaemon( true );
      return t;
    }
  };

}
