package net.antonioshome.clexec.main;

import java.util.concurrent.Future;
import net.antonioshome.clexec.ProcessExecutor;
import net.antonioshome.clexec.ProcessExecutorFactory;
import net.antonioshome.clexec.ProcessStreams;

/**
 * A class used to launch arbitrary operating system commands.
 * This class is included here for demonstration purposes, as an example.
 * It can also be used to launch arbitrary operating system commands
 *   from within Java.
 * @author Antonio Vieiro (antonio@antonioshome.net)
 * @author $Author: $
 * @version $Revision: $
 */
public final class Main
{
  private Main() {}
  /**
   * Launches the command specified by the given arguments.
   * @param args The command and its arguments.
   * @throws java.lang.Exception if an error happens.
   */
  public static void main(String[] args)
    throws Exception
  {
    StringBuffer sb = new StringBuffer();
    for (String arg : args)
      sb.append(arg).append(" ");
    ProcessExecutor executor = ProcessExecutorFactory.getDefault();
    Future<Integer> value = executor.execute( ProcessStreams.DEFAULT, null, sb.toString() );

    System.exit( value.get() );

  }
}
